<script lang="ts">
  let registry: string = "";
  let user: string = "";
  let pwd: string = "";
  let registry_block = {
    username: "",
    password: "",
    auth: "",
  };
  const gen_val = (r: string, u: string, p: string) => {
    let r_block = {
      auths: {},
    };
    registry_block.username = u;
    registry_block.password = p;
    registry_block.auth = btoa(`${u}:${p}`);
    r_block.auths[registry] = registry_block;
    return btoa(JSON.stringify(r_block));
  };

  const copy_value = () => {
    navigator.clipboard.writeText(gen_val(registry, user, pwd));
  };
</script>

<div class="form">
  <div class="line">
    <input
      type="text"
      name="registry"
      id="registry"
      placeholder="Registry FQDN (e.g. myregistry.azurecr.io)"
      bind:value={registry}
    />
  </div>
  <div class="line">
    <input
      type="text"
      name="user"
      id="user"
      placeholder="Username"
      bind:value={user}
    />
  </div>
  <div class="line">
    <input
      type="password"
      name="secret"
      id="secret"
      placeholder="Secret"
      bind:value={pwd}
    />
  </div>
  <div class="line">
    <div class="horiz">
      <div class="b64secret">{gen_val(registry, user, pwd)}</div>
      <span class="material-symbols-outlined" on:click={copy_value}>
        content_copy
      </span>
    </div>
  </div>
</div>

<style>
  .form {
    display: flex;
    flex-direction: column;
    width: 100%;
    align-items: center;
  }
  .horiz {
    display: flex;
    flex-direction: row;
    margin: 2rem;
  }
  .line input {
    padding: 0.4em;
    font-size: 1.8em;
    border-radius: 0.2em;
  }
  .b64secret {
    font-family: "Courier New", Courier, monospace;
    overflow-wrap: break-word;
    max-width: 80%;
    padding: 1.5rem;
    font-size: 0.8rem;
    background-color: #ccc;
    color: #000;
  }
</style>
